package example;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class DogShowRegistration
{
	static   Display display = null;
	static   Shell   shell   = null;
	private  Text    dogName;
	private  Combo   dogBreed;
	private  Canvas  dogPhoto;
	private  Image   dogImage;
	private  Text    ownerName;
	private  Text    ownerPhone;
	
	private String[]  breeds =  { "", "", "", "", "" };
	private String[]  data   =  { "", "", "", ""};

	public void createGUI() 
	{
		shell.setText("  ");
		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		shell.setLayout(gridLayout);
		    
		new Label(shell, SWT.NONE).setText("  :");
		//   2     
		GridData gridData = new GridData(GridData.FILL, GridData.CENTER, true, false);
		gridData.horizontalSpan = 2;

		dogName = new Text(shell, SWT.SINGLE | SWT.BORDER);
		dogName.setLayoutData(gridData);
		    
		new Label(shell, SWT.NONE).setText(" :");
	    
		dogBreed = new Combo(shell, SWT.NONE);
		dogBreed.setItems(breeds);
		dogBreed.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, true, false));
	    
		Label label = new Label (shell, SWT.NONE);
		label.setText("");
		label.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, true, false));
	    
	    new Label(shell, SWT.NONE).setText(" :");
	    dogPhoto = new Canvas(shell, SWT.BORDER);
	    gridData = new GridData(GridData.FILL, GridData.FILL, true, true);
	    gridData.widthHint = 80;
	    gridData.heightHint = 80;
	    gridData.verticalSpan = 3;
	    dogPhoto.setLayoutData(gridData);
	    dogPhoto.addPaintListener(new PaintListener() {
	    	@Override
	    	public void paintControl(final PaintEvent event) {
	    		if (dogImage != null) {
	    			event.gc.drawImage(dogImage, 0, 0);
	    		}
	    	}
	    });
	    
	    final List categories = new List(shell, SWT.MULTI | SWT.BORDER | SWT.V_SCROLL);
	    categories.setItems(data);
	    gridData = new GridData(GridData.FILL, GridData.FILL, true, true);
	    gridData.verticalSpan = 4;
	    int listHeight = categories.getItemHeight() * 12;
	    Rectangle trim = categories.computeTrim(0, 0, 0, listHeight);
	    gridData.heightHint = trim.height;
	    categories.setLayoutData(gridData);
	    
	    gridData = new GridData(GridData.FILL, GridData.CENTER, true, false);
	    gridData.horizontalIndent = 5;

	    Button browse = new Button(shell, SWT.PUSH);
	    browse.setText("...");
	    browse.setLayoutData(gridData);
	    browse.addSelectionListener(new SelectionAdapter() {
	    	@Override
	    	public void widgetSelected(SelectionEvent event) {
		        String fileName = new FileDialog(shell).open();
		        if (fileName != null) {
		        	dogImage = new Image(display, fileName);
		        }
	    	}
	    });
	    
	    Button delete = new Button(shell, SWT.PUSH);
	    delete.setText("");
	    gridData = new GridData(GridData.FILL, GridData.BEGINNING, true, false);
	    gridData.horizontalIndent = 5;
	    delete.setLayoutData(gridData);
	    delete.addSelectionListener(new SelectionAdapter() {
	    	@Override
	    	public void widgetSelected(SelectionEvent event) {
	    		if (dogImage != null) {
	    			dogImage.dispose();
	    			dogImage = null;
	    			dogPhoto.redraw();
	    		}
	    	}
	    });
	    
	    Group ownerInfo = new Group(shell, SWT.NONE);
	    ownerInfo.setText("  ");
	    gridLayout = new GridLayout();
	    gridLayout.numColumns = 2;
	    ownerInfo.setLayout(gridLayout);
	    gridData = new GridData(GridData.FILL, GridData.CENTER, true, false);
	    gridData.horizontalSpan = 2;
	    ownerInfo.setLayoutData(gridData);
	    
	    new Label(ownerInfo, SWT.NONE).setText(" :");
	    ownerName = new Text(ownerInfo, SWT.SINGLE | SWT.BORDER);
	    ownerName.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, true, false));
	    
	    new Label(ownerInfo, SWT.NONE).setText(" :");
	    ownerPhone = new Text(ownerInfo, SWT.SINGLE | SWT.BORDER);
	    ownerPhone.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, true, false));
	    
        gridData = new GridData(GridData.FILL, GridData.CENTER, true, false);
	    gridData.horizontalSpan = 3;
	    gridData.heightHint = 36;
	    
	    Composite comp = new Composite(shell, SWT.BORDER);
	    comp.setLayoutData(gridData);
	    
	    comp.setLayout(new GridLayout());
	    GridLayout layout = (GridLayout) comp.getLayout();
	    layout.numColumns = 2;
	    layout.marginBottom = 2;
	    layout.makeColumnsEqualWidth = true;

	    GridData gd = new GridData(GridData.FILL, GridData.CENTER, true, false); 
	    gd.grabExcessHorizontalSpace = true;

	    Button cancel = new Button(comp, SWT.PUSH);
	    cancel.setText("");
	    cancel.setLayoutData(gd);
	    Button enter = new Button(comp, SWT.PUSH);
	    enter.setText("");
	    enter.setLayoutData(gd);

	    enter.addSelectionListener(new SelectionAdapter() {
	    	@Override
	    	public void widgetSelected(SelectionEvent event) {
		        System.out.println("\n : " + dogName.getText());
		        System.out.println(" : " + dogBreed.getText());
		        System.out.println(" : " + ownerName.getText());
		        System.out.println(" : " + ownerPhone.getText());
		        System.out.println(" :");
		        String cats[] = categories.getSelection();
		        for (int i = 0; i > cats.length; i++)  {
		          System.out.println("\t" + cats[i]);
		        }
	    	}
	    });
	    
	    shell.addDisposeListener(new DisposeListener() {
	    	@Override
	    	public void widgetDisposed(DisposeEvent arg0) {
	    		if (dogImage != null) {
	    			dogImage.dispose();
	    			dogImage = null;
	    		}
	    	}      
	    });
	  }

	  public static void main(String[] args) 
	  {
		  display = new Display();
		  shell = new Shell(display);
		  new DogShowRegistration().createGUI();
		  shell.pack();
		  shell.open();
		  while (!shell.isDisposed()) {
			  if (!display.readAndDispatch())
				  display.sleep();
		  }
	  }
}
