package example;

import org.eclipse.swt.SWT;

import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;

import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.FormAttachment;

public class FormLayoutExample 
{
	/**
	 *           
	 * @param parent
	 */
	private static void createButtons(Shell parent)
	{
		Button btnOk = new Button (parent, SWT.PUSH);
		btnOk.setText ("OK");
		
		FormData fdOk = new FormData (60, 24);
		fdOk.right    = new FormAttachment (100, -70);
		fdOk.bottom   = new FormAttachment (100,-5);
		btnOk.setLayoutData (fdOk);

		Button btnCancel = new Button (parent, SWT.PUSH);
		btnCancel.setText ("");
		//  btnCancel   btnOk   
		FormData fdCancel = new FormData (60, 24);
		fdCancel.right    = new FormAttachment (100, -10);
		fdCancel.top      = new FormAttachment (btnOk, 0, SWT.TOP);
		btnCancel.setLayoutData (fdCancel);
	}
	/**
	 *          
	 * @param parent
	 */
	private static void createGUI(Shell parent)
	{
		//  
		Label lblLogin = new Label (parent, SWT.NONE);
		lblLogin.setText ("");
		
		FormData formData = new FormData (60, 20);
		formData.top      = new FormAttachment (0, 10);
		formData.left     = new FormAttachment (0, 10);
		lblLogin.setLayoutData (formData);

		Text txtLogin = new Text (parent, SWT.BORDER);
		
		formData = new FormData (SWT.DEFAULT, SWT.DEFAULT);
		formData.top      = new FormAttachment (0, 10);
		formData.left     = new FormAttachment (lblLogin, 10);
		formData.right    = new FormAttachment (100     ,-10);
		formData.height   = 16;
		txtLogin.setLayoutData (formData);		

		//  
		Label lblPassword = new Label (parent, SWT.NONE);
		lblPassword.setText ("");
		
		formData = new FormData (60, 20);
		formData.top      = new FormAttachment (lblLogin, 10);
		formData.left     = new FormAttachment (0, 10);
		lblPassword.setLayoutData (formData);

		Text txtPassword = new Text (parent, SWT.BORDER);
		txtPassword.setEchoChar('*');
		
		formData = new FormData (SWT.DEFAULT, SWT.DEFAULT);
		formData.top      = new FormAttachment (txtLogin, 10);
		formData.left     = new FormAttachment (lblLogin, 10);
		formData.right    = new FormAttachment (100     ,-10);
		formData.height   = 16;
		txtPassword.setLayoutData (formData);
		
		createButtons(parent);
	}
	public static void main (String [] args) 
	{
		Display display = new Display ();
		Shell shell = new Shell (display);

		shell.setText(" FormLayout");

		shell.setLayout (new FormLayout());
		
		createGUI(shell);
		
		shell.setSize(280, 150);
		shell.open ();
		
		while (!shell.isDisposed ()) {
			if (!display.readAndDispatch ()) display.sleep ();
		}
		display.dispose ();
	}
}
